/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.stimmzettel.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class StimmzettelTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String nummer;
    public java.lang.String getNummer(){
      return nummer;
    }
  protected final de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK;
    public de.ivu.elect.business.gebietsbaum.entity.GebietTK getGebietTK(){
      return gebietTK;
    }

  public StimmzettelTK(
java.lang.String nummer
,   de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK
  ) {
    super();


      this.nummer = nummer;
        this.gebietTK = gebietTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((nummer == null) ? 0 : nummer.hashCode());
        
                    result = result + ((gebietTK == null) ? 0 : gebietTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof StimmzettelTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        StimmzettelTK other = (StimmzettelTK) obj;

                if (nummer == null) {
          if (other.nummer != null) {
            return false;
          }
        } else if (!nummer.equals(other.nummer)) {
          return false;
        }
        
                if (gebietTK == null) {
          if (other.gebietTK != null) {
            return false;
          }
        } else if (!gebietTK.equals(other.gebietTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return StimmzettelConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StimmzettelConstants.MESSAGE_KEY_ENTITY_EINZAHL, StimmzettelConstants.MESSAGE_KEY_NUMMER_EINZAHL, nummer));
        
        return result;
      }


            @Override
            public String toString() {
            return "StimmzettelTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"nummer="+nummer
                                        +", gebietTK="+gebietTK
            
            ;
                            return result;
            
            }
  
  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
    + messages.getMessageForMessageKey(StimmzettelConstants.MESSAGE_KEY_NUMMER_EINZAHL) + "=" + nummer
    + ", " +  toStringLokalisiert(gebietTK, messages)
                + "]"

            ;
  }

            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Stimmzettel> java.util.Map<StimmzettelTK, E> mappeStimmzettelNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Stimmzettel::getStimmzettelTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Stimmzettel, StimmzettelTK> getStimmzettelToTKFunction() {
                return Stimmzettel::getStimmzettelTK;
                }

}
